#main file defining the GUI and operated the whole program
from enthought.traits.api import Str, Float, Int, Enum, File, Array, HasTraits, Event, Button, Instance, Bool, List, Dict
from enthought.traits.ui.api import View, ArrayEditor, CheckListEditor, Item, Group, ButtonEditor, HSplit
from enthought.traits.ui.menu import NoButtons, OKButton, CancelButton
import io_rw, FFTH_elas, analytical 
import FFTH_ve
#import dbg
#import string
import numpy as np
import my_figure

class ControlPanel(HasTraits):
    #indendation:
    ind_file_CSM = File('/home/jarda/Documents/PYTHON/GRANT/src/CSM/SCC2@2#2.EIT.res_only.txt')
    ind_import_CSM = Button()
    ind_nu_CSM_choice = Enum('from input file','as')
    ind_nu_CSM = Float(0.35)
    ind_Ei_Hys = Float(1141.)
    ind_nui_Hys = Float(0.07)
    ind_file_Hys = File('/home/jarda/Documents/PYTHON/GRANT/src/Hysitron/multiple_1_full.txt')
    ind_nu_Hys = Float(0.35)
    ind_import_Hys = Button()
    ind_Hys_bool = Bool(False)
    ind_E = Array(np.float,editor = ArrayEditor(width = 140))
    ind_E_input = Array(np.float,editor = ArrayEditor(width = 140))
    ind_nu = Array(np.float,editor = ArrayEditor(width = 140))
    ind_N = Array(np.float, (2,),editor = ArrayEditor(width = 140))
    ind_Y = Array(np.float, (2,),editor = ArrayEditor(width = 140))
    ind_h = Array(np.float, (2,),editor = ArrayEditor(width = 140))
    ind_input = Bool()
    ind_input_name = File('/home/jarda/Documents/PYTHON/GRANT/src/test_data/input.txt')
    ind_draw_what = Enum('E','nu')
    ind_draw_type = Enum('2D - contour','3D - contour')
    ind_draw = Button()
    ind_validation = Enum('none','local average','global average')
    ind_make_input = Button()
    #calculation
    ffth_calc_file = File('/home/jarda/Documents/PYTHON/GRANT/src/test_data/input.txt')
    ffth_calc_output_file  = File('/home/jarda/Documents/PYTHON/GRANT/src/test_data/output.txt')
    ffth_tol = Float(1e-4)
    ffth_maxit = Int(1000)
    ffth_calc = Button()
    #postprocessing
    pp_file = File('/home/jarda/Documents/PYTHON/GRANT/src/test_data/output.txt')
    pp_update = Button()
    pp_load = Array(np.float, (3,),editor = ArrayEditor(width = 40))
    pp_draw_what = Enum('strain_11','strain_22','strain_12','stress_11','stress_22','stress_12','L_11','L_12','L_13','L_22','L_23','L_33')
    pp_draw_type = Enum('2D - contour','3D - contour')
    pp_draw = Button()
    pp_L_eff = Array(np.float, (3,3),editor = ArrayEditor(width = 140))
    pp_kit = Array(np.int, (1,3),editor = ArrayEditor(width = 140))
    pp_resnorm = Array(np.float, (1,3),editor = ArrayEditor(width = 140))\
    #analytical homogenization
    ah_input_file = File('/home/jarda/Documents/PYTHON/GRANT/src/analytical/output_decon.txt')
    ah_output_file = File('/home/jarda/Documents/PYTHON/GRANT/src/analytical/output_analytical.txt')
    ah_import = Button()
    ah_Mphase_input = Int(0)
    ah_Mphase = Array(np.int, (1,),editor = ArrayEditor(width = 50))
    ah_Mf = Array(np.float64, (1,),editor = ArrayEditor(width = 50))
    ah_ME = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
    ah_Mnu = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
#    ah_calc = Button()
    ah_E_V = Array(np.float64, (1,), editor = ArrayEditor(width = 140))
    ah_nu_V = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
    ah_E_R = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
    ah_nu_R = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
    ah_E_HSW_lower = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
    ah_nu_HSW_lower = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
    ah_E_HSW_upper = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
    ah_nu_HSW_upper = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
    ah_E_MT = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
    ah_nu_MT = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
    ah_E_SCS = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
    ah_nu_SCS = Array(np.float64, (1,),editor = ArrayEditor(width = 140))
    ah_input = dict()
    #viscoelasticity
    ve_input = Dict()
    ve_ind_file = File('/home/jarda/Documents/PYTHON/GRANT/src/visco/curves_RH30_#2.TXT')
    ve_parameters_file = File('/home/jarda/Documents/PYTHON/GRANT/src/test_data/input_ve.txt')
    ve_import = Button()
    ve_no_time_steps = Int(10)
    ve_calc_input_file = File('/home/jarda/Documents/PYTHON/GRANT/src/test_data/input_ve.txt')
    ve_update = Button()
    ve_t_L = Float(0.)
    ve_t_H = Float(0.)
    ve_time_step = Float(0.)
    ve_t_L_round = Float(0.)
    ve_tol = Float(1e-4)
    ve_maxit = Int(1000)
    ve_calc_output_file = File('/home/jarda/Documents/PYTHON/GRANT/src/test_data/output_ve.txt')
    ve_calc = Button()
    
    def _init_(self):
        self.ve_time_step = self.ve_t_H/self.ve_no_time_steps
        self.ve_t_L_round = np.round(self.ve_t_L/self.ve_time_step)*self.ve_time_step
    
    def _ind_draw_fired(self):
        try:
            if self.ind_draw_what=='E':
                Z = self.ind_E
            elif self.ind_draw_what=='nu':
                Z = self.ind_nu
            else:
                pass
            my_figure.field(self.ind_draw_type,self.ind_draw_what,Z,self.ind_Y)
        except Exception as err:
            print('The figure has not been produced.')
            print(err)
                        
    def _ind_import_CSM_fired(self):
        try:
            inputs = io_rw.read_results_CSM(self.ind_file_CSM)
            self.ind_N = inputs['N']
            self.ind_Y = inputs['Y']
            if self.ind_nu_CSM_choice == 'from input file':
                self.ind_nu = inputs['nu']
                self.ind_E = inputs['E']
            elif self.ind_nu_CSM_choice == 'as':
                self.ind_nu = self.ind_nu_CSM*np.ones(self.ind_N)
                self.ind_E = inputs['E']/(1-inputs['nu']**2)*(1-self.ind_nu_CSM**2)
            else:
                pass
            self.ind_h = inputs['h']
            self.ind_Hys_bool = False
            print('The CSM file has been successfully loaded.')
        except Exception as err:
            print('The CSM file has not been successfully loaded.')
            print(err)
        
    def _ind_import_Hys_fired(self):
        try:
            input = io_rw.read_results_Hys(self.ind_file_Hys)
            self.ind_N = input['N']
            self.ind_Y = input['Y']
            self.ind_E = (1-self.ind_nu_Hys**2.)/(1/input['E']-(1-self.ind_nui_Hys**2.)/self.ind_Ei_Hys)
            self.ind_h = input['h']
            self.ind_nu = self.ind_nu_Hys*np.ones(self.ind_N)
            self.ind_Hys_bool = True
            print('The Hysitron file has been successfully loaded.')
        except Exception as err:
            print('The Hysitron file has not been successfully loaded.')
            print(err)
    
    def _ind_h_changed(self):
        self.ind_Y = self.ind_N*self.ind_h
        
    
    def _ind_make_input_fired(self):
        self.ind_E_input = self.ind_E.copy() 
        if self.ind_validation == 'local average':
            try:
                T = self.ind_E<0
                for i in np.arange(self.ind_N[0]):
                    for j in np.arange(self.ind_N[1]):
                        if T[i][j]:
                            if i>=self.ind_N[0]-2:
                                i = i-self.ind_N[0]
                            if j>=self.ind_N[1]-2:
                                j = j-self.ind_N[1]
                            loc = np.array([self.ind_E[i+1][j],self.ind_E[i-1][j],self.ind_E[i][j+1],self.ind_E[i-1][j]])
                            loc2 = np.array([self.ind_E[i+1][j+1],self.ind_E[i-1][j-1],self.ind_E[i-1][j+1],self.ind_E[i+1][j-1]],)
                            T_loc = loc<0
                            T_loc2 = loc2<0
                            average_loc = sum((1.-T_loc)*loc)/(len(loc)-sum(T_loc))
                            average_loc2 = sum((1.-T_loc2)*loc2)/(len(loc2)-sum(T_loc2))
                            self.ind_E_input[i][j] = 0.6*average_loc + 0.4*average_loc2
                        else:
                            pass
                print('Data were adjusted with local average.')
            except Exception as err:
                print('Error during data validation.')
        elif self.ind_validation == 'global average':
            try:
                T = self.ind_E<0
                self.ind_E_input = sum((1.-T)*self.ind_E)/(np.prod(T.shape)-sum(T))
                print('Data were adjusted with global average.')
            except Exception as err:
                print('Error during data validation.')
            
        try:
            input = dict()
            input['Y'] = self.ind_Y
            input['E'] = self.ind_E_input
            input['nu'] = self.ind_nu
            fmt = '%.6e';delimiter = ' '
            io_rw.io_write('input_FFTH',input,self.ind_input_name,fmt,delimiter)
            self.ffth_calc_file = self.ind_input_name
            print('The input file for FFT-homogenization has been produced.')
        except Exception as err:
            print(err)

    def _ffth_calc_fired(self):
        try:
            variables = ['E','nu','Y','tol','maxit']
            inputs = io_rw.io_read(self.ffth_calc_file,variables)
            K = inputs['E']/(3*(1-2*inputs['nu']))
            G = inputs['E']/(2*(1+inputs['nu']))
            inputs['L'] = FFTH_elas.get_L_Man(K,G)
            inputs['tol'] = self.ffth_tol; inputs['maxit'] = self.ffth_maxit
            inputs['K0'],inputs['G0'] = FFTH_elas.get_K0_G0(K,G)
            fmt = '%.5e'; delimiter = ' '
            output = FFTH_elas.homogenization(inputs)
            output['tol'] = self.ffth_tol
            output['maxit'] = self.ffth_maxit
            io_rw.io_write('output_FFTH',output, self.ffth_calc_output_file, fmt, delimiter)
            self.pp_file = self.ffth_calc_output_file
            print('The FFT-homogenization is finished.')
            self.fffh_postprocessing()
        except Exception as err:
            print(err)
    
    def _pp_update_fired(self):
        self.fffh_postprocessing()
    
    def fffh_postprocessing(self):
        try:
            variables = ['L_eff','kit','resnorm','strain','L','Y']
            self.output = io_rw.io_read(self.pp_file,variables)
            self.pp_L_eff = self.output['L_eff']
            self.pp_kit = [self.output['kit']]
            self.pp_resnorm = [self.output['resnorm']]
            print('The postprocessing of FFT homogenization is finished.')
        except Exception as err:
            print(err)
        
        
    def _pp_draw_fired(self):
        try:
            dummy,D,dummy,DN = FFTH_elas.get_dimensions(self.output['strain'][0][0])
            data = {}
            data['strain'] = np.zeros(DN)
            for iL in np.arange(D):
                data['strain'] +=  self.pp_load[iL] * self.output['strain'][iL]
            
            data['stress'] = FFTH_elas.mult_Lep(self.output['L'],data['strain'],D,DN)
            if self.pp_draw_what[0] == 'L':
                Z = self.output['L'][int(self.pp_draw_what[-2])-1][int(self.pp_draw_what[-1])-1]
            elif self.pp_draw_what[0:6] in ['stress','strain']:
                if self.pp_draw_what[-2] == '1' and self.pp_draw_what[-1] == '1':
                    Z = data[self.pp_draw_what[0:6]][0]
                elif self.pp_draw_what[-2] == '2' and self.pp_draw_what[-1] == '2':
                    Z = data[self.pp_draw_what[0:6]][1]
                elif self.pp_draw_what[-2] == '1' and self.pp_draw_what[-1] == '2':
                    Z = data[self.pp_draw_what[0:6]][2]
                else:
                    pass
            else:
                pass
                
            my_figure.field(self.pp_draw_type,self.pp_draw_what,Z,self.output['Y'])
        except Exception as err:
            print(err)
    
    def _ah_import_fired(self):
        try:
            self.ah_input = io_rw.read_analytical(self.ah_input_file)
            print('The input file for analytical homogenization has been successfully loaded.')
            f = self.ah_input['f']
            self.ah_Mphase_input = np.int(np.nonzero(f==max(f))[0]) + 1
        except Exception as err:
            print(err)
            
    def _ah_Mphase_input_changed(self):
        try:
            if 0 < self.ah_Mphase_input and self.ah_Mphase_input < np.size(self.ah_input['f']) + 1:
                self.ah_Mphase = [self.ah_Mphase_input]
                self.ah_Mf = self.ah_input['f'][self.ah_Mphase-1]
                self.ah_ME = self.ah_input['E'][self.ah_Mphase-1]
                self.ah_Mnu = self.ah_input['nu'][self.ah_Mphase-1]
                self.ah_calculate()
            else:
                print('The no. of matrix phase is out of range.')
        except Exception as err:
            print(err)
    
    def ah_calculate(self):
        try:
            E = self.ah_input['E']
            nu = self.ah_input['nu']
            f = self.ah_input['f']
            ind_Mphase = self.ah_Mphase - 1
            K,G = FFTH_elas.Enu2KG(E,nu)
            
            K_MT, G_MT = analytical.MoriTanaka(K,G,f,ind_Mphase)
            K_SCS, G_SCS = analytical.SelfConsistent(K,G,f)
            K_V,G_V,K_R,G_R = analytical.Voight_Reuss(K,G,f)
            K_HSW_lower,G_HSW_lower,K_HSW_upper,G_HSW_upper = analytical.HashinShtrikmanWalpole(K,G,f)
            
            outputs = dict()
            outputs['E_V'],outputs['nu_V'] = FFTH_elas.KG2Enu(K_V, G_V)
            outputs['E_R'],outputs['nu_R'] = FFTH_elas.KG2Enu(K_R, G_R)
            outputs['E_MT'],outputs['nu_MT'] = FFTH_elas.KG2Enu(K_MT, G_MT)
            outputs['E_SCS'],outputs['nu_SCS'] = FFTH_elas.KG2Enu(K_SCS, G_SCS)
            outputs['E_HSW_lower'],dummy = FFTH_elas.KG2Enu(K_HSW_lower, G_HSW_lower)
            outputs['E_HSW_upper'],dummy = FFTH_elas.KG2Enu(K_HSW_upper, G_HSW_upper)
            dummy,outputs['nu_HSW_lower'] = FFTH_elas.KG2Enu(K_HSW_lower, G_HSW_upper)
            dummy,outputs['nu_HSW_upper'] = FFTH_elas.KG2Enu(K_HSW_upper, G_HSW_lower)
            fmt = '%.5e'; delimiter = ' '
            io_rw.io_write('output_analytical',outputs, self.ah_output_file, fmt, delimiter)
            self.ah_E_V = [outputs['E_V']]
            self.ah_nu_V = [outputs['nu_V']]
            self.ah_E_R = [outputs['E_R']]
            self.ah_nu_R = [outputs['nu_R']]
            self.ah_E_HSW_lower = [outputs['E_HSW_lower']]
            self.ah_nu_HSW_lower = [outputs['nu_HSW_lower']]
            self.ah_E_HSW_upper = [outputs['E_HSW_upper']]
            self.ah_nu_HSW_upper = [outputs['nu_HSW_upper']]  
            self.ah_E_MT = [outputs['E_MT']]
            self.ah_nu_MT = [outputs['nu_MT']]
            self.ah_E_SCS = [outputs['E_SCS']]
            self.ah_nu_SCS = [outputs['nu_SCS']]
            print('The analytical homogenization has been successfully performed.')
        except Exception as err:
            print(err)
            
    def _ve_import_fired(self):
        try:
            self.ve_inputs = io_rw.read_visco(self.ve_ind_file)
            self.ve_t_H = np.mean(self.ve_inputs['t_H'])
            self.ve_t_L = np.mean(self.ve_inputs['t_L'])
            fmt = '%.5e'; delimiter = ' '
            io_rw.io_write('input_ve',self.ve_inputs, self.ve_parameters_file, fmt, delimiter)
            self.ve_calc_input_file = self.ve_parameters_file
            print('The visco-elastic parameters were identified and written into the file.')
        except Exception as err:
            print(err)
    
    def _ve_no_time_steps_changed(self):
        try:
            if self.ve_no_time_steps>0:
                self.ve_time_step = self.ve_t_H/self.ve_no_time_steps
                self.ve_t_L_round = np.round(self.ve_t_L/self.ve_time_step)*self.ve_time_step
            else:
                print('The number of time steps has to be a positive integer.')
        except Exception as err:
            print(err)
            
    def _ve_t_H_changed(self):
        try:
            self.ve_time_step = self.ve_t_H/self.ve_no_time_steps
            self.ve_t_L_round = np.round(self.ve_t_L/self.ve_time_step)*self.ve_time_step
        except Exception as err:
            print(err)
            
    def _ve_t_L_changed(self):
        try:
            self.ve_t_L_round = np.round(self.ve_t_L/self.ve_time_step)*self.ve_time_step
        except Exception as err:
            print(err)            
    
    def read_ve_inputs(self):
        variables = ['E','nu','eta_M','G_V','eta_V','N','Y','t_L','t_H']
        self.ve_inputs = io_rw.io_read(self.ve_calc_input_file, variables)
    
    def _ve_update_fired(self):
        try:
            self.read_ve_inputs()
            self.ve_t_H = np.mean(self.ve_inputs['t_H'])
            self.ve_t_L = np.mean(self.ve_inputs['t_L'])
            print('Visco-elastic parameters were read from input file')
            print('The recommended parameters were set.')
        except Exception as err:
            print(err)
            
    def _ve_calc_fired(self):
        try:
#            variables = ['E','nu','eta_M','G_V','eta_V','N','Y','t_L','t_H']
#            inputs = io_rw.io_read(self.ve_calc_input_file, variables)
#            print('Visco-elastic parameters were read from input file.')
            self.read_ve_inputs()
            
            self.ve_inputs['no_time_steps'] = self.ve_no_time_steps
            self.ve_inputs['t_L'] = self.ve_t_L
            self.ve_inputs['t_H'] = self.ve_t_H
            self.ve_inputs['time_step'] = self.ve_time_step
            self.ve_inputs['tol'] = self.ve_tol
            self.ve_inputs['maxit'] = self.ve_maxit
            outputs = FFTH_ve.homogenization_ve(self.ve_inputs)
            print('The visco-elastic FFT-homogenization was proceeded.')

            fmt = '%.5e'; delimiter = ' '
            io_rw.io_write('output_ve',outputs, self.ve_calc_output_file, fmt, delimiter)
            print('The data from visco-elastic FFT-homogenization were written into the file.')
        except Exception as err:
            print(err)
            
    view = View(
        #Indentation input        
        Group(Group(Item('ind_file_CSM',label="CSM indentation file"),
                    HSplit(Item('ind_nu_CSM_choice',label="Choose Poissons ratio",show_label=True),
                    Item('ind_nu_CSM',label="Poissons ratio",show_label=False),),
                      Item('ind_import_CSM',label="Import",show_label=False),
                      label="Input data from nanoindentation - CSM",show_border=True),
            Group(Item('ind_file_Hys',label="Hysitron indentation file"),
                  Item('ind_Ei_Hys',label="Young's modulus of indenter"),
                  Item('ind_nui_Hys',label="Poisson\'s ratio of indenter"),
                  Item('ind_nu_Hys',label="Poisson\'s ratio"),
                      Item('ind_import_Hys',label="Import",show_label=False),
                      label="Input data from nanoindentation - Hysitron",show_border=True),
            Group(Item('ind_N',label="No. of discretization points (N_1 x N_2)",style='readonly'),
                            Item('ind_Y',label="Size of periodic unit cell (Y_1 x Y_2)",style='readonly'),
                            Item('ind_h',label="Discretization step (h_1 x h_2)"),
                            HSplit(Item('ind_draw_what',label="Drawing of"),
                                   Item('ind_draw_type',label="using"),
                                   Item('ind_draw',label="Draw",show_label=False),),
                            label="Data from input file",show_border=True),
              Group(Item('ind_validation',label="Substitution of defected values with"),
                    Item('ind_input_name',label="Name of input file"),
                    Item('ind_make_input',label="Make input file",show_label=False),
                            label="Creation of input file",show_border=True,),
                    label="Indentation"),
        #FFT-homogenization        
        Group(Group(Item('ffth_calc_file',label="Input file"),
                      Item('ffth_tol',label="Tolerance for CG convergence"),
                      Item('ffth_maxit',label="Maximum no. of CG iterations"),
                      label="Inputs for FFTH homogenization",show_border=True),
            Group(Item('ffth_calc_output_file',label="Name of output file"),
                    Item('ffth_calc',label="Calculate",show_label=False),
                      label="Calculation",show_border=True),
                    label="FFT Homogenization"),
        #FFTH-postprocessing        
        Group(Group(Item('pp_file', label='Name of output file'),
                    Item('pp_update',label="update",show_label=False),
              label="Postprocessing file",show_border=True),
              Group(Item('pp_L_eff',style='readonly',label="Effective stiffness\n(Mandel notation)"),
                      Item('pp_kit',style='readonly',label='No. of iterations (kit)'),
                      Item('pp_resnorm',style='readonly',label="Residual norm (resnorm)"),
                      label="Outputs",show_border=True),
            Group(Item('pp_load',label="Loading [strain_11, strain_22, strain_12]"),
                  HSplit(Item('pp_draw_what',label="Drawing of"),
                         Item('pp_draw_type',label="using"),
                         Item('pp_draw',label="Draw",show_label=False),),
                        label="Drawing of local fields",show_border=True),
                    label="FFTH Postprocessing"),
        #Analytical homogenization        
        Group(Group(Item('ah_input_file', label='Name of input file'),
                    Item('ah_output_file', label='Name of output file'),
                    Item('ah_import', label='Import and calculate', show_label=False),
                    Item('ah_Mphase_input', label='No. of matrix phase'),
                    HSplit(Item('ah_Mphase', label='No. of matrix phase',style='readonly'),
                           Item('ah_Mf', label='Phase ratio',style='readonly'),
                           Item('ah_ME', label='E',style='readonly'),
                           Item('ah_Mnu', label='nu',style='readonly'),
                           ),
                    label="Input and calculation",show_border=True),
#              Group(
#                    Item('ah_calc', label='Calculate', show_label=False),
#                    label="Calculation",show_border=True),
              Group(HSplit(Group(Item('ah_E_V',style='readonly', label="Young's modulus by Voight"),
                    Item('ah_nu_V',style='readonly', label="Poison's ratio by Voight"),),
                    Group(Item('ah_E_R',style='readonly', label="Young's modulus by Reuss"),
                    Item('ah_nu_R',style='readonly', label="Poison's ratio by Reuss"),),),
                    label="Voight-Reuss upper and lower bounds",show_border=True),
              Group(HSplit(Group(Item('ah_E_HSW_lower',style='readonly', label="lower bound of Young's modulus"),
                    Item('ah_nu_HSW_lower',style='readonly', label="lower bound of Poison's ratio"),),
                    Group(Item('ah_E_HSW_upper',style='readonly', label="upper bound of Young's modulus"),
                    Item('ah_nu_HSW_upper',style='readonly', label="upper bound of Poison's ratio"),),),
                    label="Hashin-Shtrikman-Walpole lower and upper bounds",show_border=True),
              Group(Item('ah_E_MT',style='readonly', label="Young's modulus by Mori-Tanaka homogenization"),
                    Item('ah_nu_MT',style='readonly', label="Poison's ratio by Mori-Tanaka homogenization"),
                    Item('ah_E_SCS',style='readonly', label="Young's modulus by Self Consistent homogenization"),
                    Item('ah_nu_SCS',style='readonly', label="Poison's ratio by Self Consistent homogenization"),
                    label="Homogenized by Mori-Tanaka and Self Consistent method",show_border=True),
                    label="Analytical Homogenization"),
            Group(Group(Item('ve_ind_file', label="Indentation file"),
                  Item('ve_parameters_file', label="Input file for homogenization"),
                        Item('ve_import', label="Import",show_label=False),
                    label="Import and identification of parameters",show_border=True),
                  Group(Item('ve_calc_input_file', label="Input file for homogenization"),
                        Item('ve_update', label="Update and set the parameters to recommended values",show_label=False),
                        Item('ve_no_time_steps', label="No. of time steps in holding phase"),
                        Item('ve_t_H', label="Duration of holding phase"),
                        Item('ve_time_step', label="Time-step",style='readonly'),
                        Item('ve_t_L', label="Duration of loading phase"),
                        Item('ve_t_L_round', label="Round off duration of loading phase",style='readonly'),
                        Item('ve_tol', label="Tolerance for CG convergence"),
                        Item('ve_maxit', label="Maximal no. of CG iterations"),
#                        HSplit(Item('ve_tol', label="Tolerance for CG convergence"),
#                        Item('ve_maxit', label="Maximal no. of CG iterations"),),
                        Item('ve_calc_output_file', label="Output file"),
                        Item('ve_calc', label="Calculate",show_label=False),
                    label="Calculation",show_border=True),
                    label="Visco-elasticity FFTH"),
            title="Homogenization",height=700,width=800)
    
panel = ControlPanel()        
panel.configure_traits()
      
      